'''
Mark Shuster
Interactive Art and Computational Design
Spring 2011
Information Visualization
'''

import urllib, urllib2
import time
import locale
import math
from BeautifulSoup import BeautifulSoup, Tag, NavigableString
import simplejson as json
from jinja2 import Environment, PackageLoader, FileSystemLoader
import Image
import cStringIO

#BILLBOARD_API_KEY = "43cwdj3gqxwehn6qfq79644v"
#BILLBOARD_URL_BASE = "http://api.billboard.com/apisvc/chart/v1/list"

MEDIABASE_URL = "http://www.mediabase.com/mmrweb/insideradio/charts.asp?SHOWYEAR=N"
MEDIABASE_COLUMN_RANK = 2
MEDIABASE_COLUMN_ARTIST = 4
MEDIABASE_COLUMN_TITLE = 5
MEDIABASE_FIRST_ROW = 1
MEDIABASE_LAST_ROW = 42

YT_API_URL = "http://gdata.youtube.com/feeds/api/videos"

THUMBNAIL_WIDTH = 480
THUMBNAIL_HEIGHT = 320

def main():
    
    chart_file = open('chart.html') #Read chart from local file to prevent server abuse
    #chart_file = urllib2.urlopen(MEDIABASE_URL)
    
    chart_html = BeautifulSoup(chart_file)
    chart = []
    
    for row in chart_html.findAll('tr', align="right")[1:MEDIABASE_LAST_ROW]: #Loop through the resulting table rows
        tr = BeautifulSoup(row.__str__())
        cells = tr.findAll('td')
        song = {
                'rank' : cells[MEDIABASE_COLUMN_RANK].span.contents[0],
                'artist' : cells[MEDIABASE_COLUMN_ARTIST].span.contents[0],
                'title' : cells[MEDIABASE_COLUMN_TITLE].span.contents[0].split('f/')[0].split('(')[0]
                }
        #print song['artist'] + " " + song['title']
        chart.append(song)

    yt_query_string = {
        'orderby': 'relevance',
        'max-results': 10,
        'v': 2,
        'alt': "json"
    }
    
    template_var_list = []
    max_views = 0
    
    for song in chart:
        yt_query_string['q'] = song['artist'] + " " + song['title']
        time.sleep(1)    
        try:
            result = json.load(urllib2.urlopen(YT_API_URL + "?" + urllib.urlencode(yt_query_string)))
            
            yt_video = {
                'title': result['feed']['entry'][0]['title']['$t'],
                'link': result['feed']['entry'][0]['link'][0]['href'],
                'thumb': 'http://i.ytimg.com/vi/' + result['feed']['entry'][0]['media$group']['yt$videoid']['$t'] + '/hqdefault.jpg ', #result['feed']['entry'][0]['media$group']['media$thumbnail'][4]['url'],
                'views': result['feed']['entry'][0]['yt$statistics']['viewCount'],
                'id': result['feed']['entry'][0]['media$group']['yt$videoid']['$t']
            }
            yt_video['views'] = max([int(entry['yt$statistics']['viewCount']) for entry in result['feed']['entry']])
                    
            
            if int(yt_video['views']) > max_views:
                max_views = yt_video['views']
            
            template_var_list.append(yt_video)
        except urllib2.HTTPError, e:
            print httperror
    
    print max_views
    
    iter = 0
    img_file_name = "test.jpg"
    width = 0 
    height = 0
    
    for song in template_var_list:
        song['scale'] = float(song['views']) / int(max_views)
        #print song['views'] + " " + str(song['scale']) + " " + song['title']
        try:
            file = urllib2.urlopen(song['thumb'])
            im = cStringIO.StringIO(file.read())
            img = Image.open(im)

        except urllib2.HTTPError, e:
            print "url fail " + song['thumb']
            song['thumb'] = str.replace(str(song['thumb']), 'hqdefault.jpg', '1.jpg')
            print song['thumb']
            file = urllib2.urlopen(song['thumb'])
            im = cStringIO.StringIO(file.read())
            img = Image.open(im)
            img = img.resize((480,360))
        except SystemError, e:
            print "img fail" + str(iter)

        tmp_img = img.copy()
        
        tmp_pixels = []
        for pixel in list(tmp_img.getdata()):
            if ((pixel[0] < 50) and (pixel[1] < 50) and (pixel[2] < 50)):
                pixel = (0,0,0)
            tmp_pixels.append(pixel)
        
        tmp_img.putdata(tmp_pixels)
        img = img.crop(tmp_img.getbbox())
        width = int(math.sqrt(song['scale']) * img.size[0])
        height =  int(math.sqrt(song['scale']) * img.size[1])
        img = img.resize((width, height))
        img_file_name = song['id'][:8] + '.jpg'
        img.save(img_file_name)
            
        song['thumb'] = img_file_name
        song['width'] = width
        song['height'] = height
    
    env = Environment(loader = FileSystemLoader('./'))
    template = env.get_template('template.html')
    
    f = open('index.html', 'w')
    f.writelines(template.render({'render_list':template_var_list}))

if __name__ == '__main__':
    main()
    